
if select(2,UnitClass('player')) ~= 'MAGE' then return end

local AC = GetSpellInfo(36032) -- Arcane Charge
local ABCount = nil

local GetFramesRegisteredForEvent = GetFramesRegisteredForEvent
local UnitDebuff = UnitDebuff

local function NotifyFrames(frame, ...)
   if frame then
      local func = frame:GetScript('OnEvent')
      if func then func(frame, 'UNIT_COMBO_POINTS', 'player') end
      return NotifyFrames(...)
   end
end

-- tell all registered frames that there are new combo points
local frame = CreateFrame('frame')
frame:RegisterUnitEvent('UNIT_AURA', 'player')
frame:SetScript('OnEvent', function(self, event, unit)
   local _,_,_,count = UnitDebuff('player', AC)
   if count ~= ABCount then
      ABCount = count
      return NotifyFrames(GetFramesRegisteredForEvent('UNIT_COMBO_POINTS'))
   end
end)

-- replace how addons get number of combo points
local UnitExists = UnitExists
local oldGetComboPoints = GetComboPoints
GetComboPoints = function(...)
   return UnitExists('target') and ABCount or oldGetComboPoints(...)
end
